using com.amazon.webservices;
using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class AmazonWebService : System.Web.UI.Page
    {
        private string MyAmazonAccessKeyID = "XXXXXXXXXXXXXXXXXXXX";

        protected void Page_Load(object sender, EventArgs e){
            if (!IsPostBack) return;
            lblError.Text="";
            try{
                AWSECommerceService aws = new AWSECommerceService();
                ItemSearch search = new ItemSearch();
                ItemSearchRequest req = new ItemSearchRequest();

                req.Keywords = txtKw.Text.ToLower();
                req.SearchIndex = ddlCat.SelectedItem.Text;
                req.ResponseGroup = new string[]{"Medium"};
                req.Sort = "salesrank";

                search.AWSAccessKeyId = MyAmazonAccessKeyID;
                search.Request = new ItemSearchRequest[] {req};

                ItemSearchResponse res = aws.ItemSearch(search);
                Item[] items = res.Items[0].Item;
                if (items == null){
                    lblError.Text="No items found!";
                    return;
                }
                for (int i = 0; i < items.Length; i++){
                    Item crt = items[i];
                    TableRow tr = new TableRow();
                    TableCell tc = new TableCell();
                    if (crt.SmallImage != null){
                        System.Web.UI.WebControls.Image img = new System.Web.UI.WebControls.Image();
                        img.ImageUrl = crt.SmallImage.URL;
                        tc.Controls.Add(img);
                    }
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    HyperLink link = new HyperLink();
                    link.Text = crt.ItemAttributes.Title;
                    link.NavigateUrl = crt.DetailPageURL;
                    tc.Controls.Add(link);
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    if (crt.ItemAttributes.Author!=null){
                        tc.Text = crt.ItemAttributes.Author[0];
                        for (int j = 1; j < crt.ItemAttributes.Author.Length; j++){
                            tc.Text += ", " + crt.ItemAttributes.Author[j];
                        }
                    }
                    tr.Cells.Add(tc);
                    tc = new TableCell();
                    if (crt.OfferSummary.LowestNewPrice != null)
                        tc.Text = crt.OfferSummary.LowestNewPrice.FormattedPrice;
                    tr.Cells.Add(tc);
                    tblRes.Rows.Add(tr);
                }

            }
            catch (Exception ex){
                lblError.Text=ex.ToString();
            }
        }
    }
