using System;
using System.Data;
using System.Data.Odbc;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml;

public partial class SearchService : System.Web.UI.Page
{
    private OdbcConnection Connection = new OdbcConnection(ConnectionString.GetConnectionString());

    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);
        Connection.Open();
    }

    public override void Dispose()
    {
        base.Dispose();
        if (Connection.State == ConnectionState.Open)
        {
            Connection.Close();
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        XmlDocument output = new XmlDocument();
		XmlNode root = output.CreateElement("livesearchresults");
		output.AppendChild(root);
        string pattern = "";
        if (Request.QueryString["pattern"] != null)
        {
            pattern = Request.QueryString["pattern"].ToString();
        }
        XmlNode node = output.CreateElement("pattern");
        node.InnerText = pattern;
        root.AppendChild(node);
        int n = countMatches(pattern);
        node = output.CreateElement("matchcount");
        node.InnerText = n.ToString();
        root.AppendChild(node);
        if (n <= 5) 
        {
            OdbcDataReader records = getRecords(pattern);
            while (records.Read())
            {
                node = output.CreateElement("student");
                String[] attributes={"firstname","lastname","email","id"};
                foreach (string attrName in attributes)
                {
                    XmlAttribute attr = output.CreateAttribute(attrName);
                    attr.Value = records[attrName].ToString();
                    node.Attributes.Append(attr);
                }   
                root.AppendChild(node);
            }
        }
		Response.Write("<?xml version=\"1.0\" encoding=\"utf-8\"?>");
		Response.Write(output.DocumentElement.OuterXml);
    }
    private int countMatches(string pattern)
    {
        int result;
        OdbcCommand command = new OdbcCommand("SELECT COUNT(id) FROM people WHERE (CONCAT(firstname,' ',lastname,' ',email) LIKE ?); ", Connection);
		command.Parameters.AddWithValue("@pattern", "%" + pattern + "%");
		result = System.Convert.ToInt32(command.ExecuteScalar());
        return result;
    }

    private OdbcDataReader getRecords(string pattern)
    {
        OdbcCommand command = new OdbcCommand("SELECT id,firstname,lastname,email FROM people WHERE (CONCAT(firstname,' ',lastname,' ',email) LIKE ?); ", Connection);
		command.Parameters.AddWithValue("@pattern", "%" + pattern + "%");
		return command.ExecuteReader();
    }
}
